var rules = [
    {
	"type": "rbb-example",
	"name": "example-rule",
	"title": "Example rule",
	"id": "a59a1e4c-c008-45b2-8412-293e4ac6760d",
	"rule": {
	    "requires": "$all",
	    "subRules": [
		{
		    "threshold": 0,
		    "comparator": ">",
		    "pointer": ["match", "playedMinutes"]
		},
		{
		    "threshold": 3,
		    "comparator": "<",
		    "pointer": ["publishes", "byName", "example-rule", "total"]
		}
	    ]
	},
	"dedupe": [
	    ["match", "playedMinutes"]
	]
    }
];

var fetchEvents = function (competitionId, seasonId, fixtureId) {
    var events_path = ['events', competitionId, seasonId, fixtureId].join('/');
    var events_url = 'https://opta-api-staging.eip.telegraph.co.uk/' + events_path;
    return window.RuleEngine.eventStream(events_url);
};

// events(8, 2016, 855231).each(function (event) {
//     console.log(event);
// });

// opta events for the match (highland stream)
var events = fetchEvents(8, 2016, 855231);

// config passed to the rbb-landscape init() function
var config = {
    teams: {
	20: {side: 'Away'},
	21: {side: 'Home'}
    }
};

// array of past publish events for this match
var publishEvents = [];

var publishes = window.RuleEngine.detector.detect(
    events,
    rules,
    publishEvents,
    config
);

publishes.each(function (event) {
    console.log(event);
});
