var detector = require('../detector');
var eventStream = require('../event-stream');
var utils = require('../utils');

var competitionId = process.argv[2] || 336; // || 8
var seasonId = process.argv[3] || 112018; // || 2016;
var fixtureId = process.argv[4] || 828085; // || 855231;

var config = {
    'local': {
        version: '0.1.8',
        optaApiUrl: 'http://localhost:5000',
        rulesApiUrl: 'http://localhost:4000'
    },
    'staging': {
        version: '0.1.8',
        optaApiUrl: 'https://opta-api-staging.eip.telegraph.co.uk',
        rulesApiUrl: 'http://particle-api-rbb.eip.telegraph.co.uk'
    }
}[ process.argv[5] || 'local' ];

utils.init (config);

utils.fetchRules(function (err, rules) {
    if (err) {
        throw err;
    }

    utils.fetchPublishes(competitionId, seasonId, fixtureId, function (err, publishes) {
        if (err) {
            throw err;
        }

        var events = utils.events(competitionId, seasonId, fixtureId);

        utils.fetchLandscapeConfig(competitionId, seasonId, fixtureId, function (err, config) {
            if (err) {
                throw err;
            }

            detector.detect(events, rules, publishes, config).each(function (result) {
                console.log('---');
                //console.log(JSON.stringify(result, null, 4));
                console.log ( result.rule.title );
            });
        });
    });
});
