var detector = require('./detector');
var eventStream = require('./event-stream');

var competitionId = process.argv[2] || 8;
var seasonId = process.argv[3] || 2016;
var fixtureId = process.argv[4] || 855239;

detector.init ({
    version: '0.1.6',
    optaApiUrl: 'https://opta-api-staging.eip.telegraph.co.uk',
    rulesApiUrl: 'http://particle-api-staging.eip.telegraph.co.uk'
});

detector.fetchRules(function (err, rules) {
    if (err) {
        throw err;
    }

    detector.fetchPublishes(competitionId, seasonId, fixtureId, function (err, publishes) {
        if (err) {
            throw err;
        }

        var events = detector.events(competitionId, seasonId, fixtureId);

        detector.fetchLandscapeConfig(competitionId, seasonId, fixtureId, function (err, config) {
            if (err) {
                throw err;
            }

            detector.detect(events, rules, publishes, config).each(function (result) {
                console.log('---');
                //console.log(JSON.stringify(result, null, 4));
                console.log ( result.rule.title );
            });
        });
    });
});
