var detector = require('../detector');
var eventStream = require('../event-stream');
var utils = require('../utils');

var rules = [
    {
	"type": "rbb-example",
	"name": "example-rule",
	"title": "Example rule",
	"id": "a59a1e4c-c008-45b2-8412-293e4ac6760d",
	"rule": {
	    "requires": "$all",
	    "subRules": [
		{
		    "threshold": 0,
		    "comparator": ">",
		    "pointer": ["match", "playedMinutes"]
		},
		{
		    "threshold": 0,
		    "comparator": "==",
		    "pointer": ["publishes", "byName", "example-rule", "currentPeriod"]
		}
	    ]
	},
	"dedupe": [
	    ["match", "playedMinutes"]
	]
    }
];
 
// this array would normally be fetched using detector.fetchPublishes
var publishes = [];

utils.init ({
    optaApiUrl: 'https://opta-api-staging.eip.telegraph.co.uk/',
    rulesApiUrl: 'http://particle-api-staging.eip.telegraph.co.uk/rules'
});

// Example OPTA URL: https://opta-api-staging.eip.telegraph.co.uk/events/8/2016/855231
// Example publishes URL: https://opta-api-staging.eip.telegraph.co.uk/publishes/8/2016/855231
// Example Rules URL: http://particle-api-staging.eip.telegraph.co.uk/rules
// Example Rules URL: http://particle-api-test.eip.telegraph.co.uk/rules


// detector.fetchRules(function (err, rules) {
//     if (err) {
//         throw err;
//     }

    // detector.fetchPublishes(8, 2016, 855231, function (err, publishes) {
    //     if (err) {
    //         throw err;
    //     }

        var events = utils.events(8, 2016, 855231);

        utils.fetchLandscapeConfig(8, 2016, 855231, function (err, config) {
            if (err) {
                throw err;
            }

            detector.detect(events, rules, publishes, config).each(function (result) {
                console.log('---');
                console.log(JSON.stringify(result, null, 4));
		// console.log(result);
            });
        });

    // });

// });
