'use strict';

module.exports = {
    PRODUCT: function(a, b) {
        var first = a,
            second = b;

        // arguments are propertySets
        if (typeof a === 'object' && Array.isArray(a.values)) {
            first = a.values[0];
        }
        if (typeof b === 'object' && Array.isArray(b.values)) {
            second = b.values[0];
        }
        if (!isNaN(parseFloat(first)) && !isNaN(parseFloat(second))) {
            return parseFloat(first) * parseFloat(second);
        } else {
            return NaN;
        }
    },
    QUOTIENT: function(a, b) {
        var first = a,
            second = b;

        // arguments are propertySets
        if (typeof a === 'object' && Array.isArray(a.values)) {
            first = a.values[0];
        }
        if (typeof b === 'object' && Array.isArray(b.values)) {
            second = b.values[0];
        }
        if (!isNaN(parseFloat(first)) && !isNaN(parseFloat(second)) && parseFloat(second)) {
            return parseFloat(first) / parseFloat(second);
        } else {
            return NaN;
        }

    },
    SUM: function(values) {
        var argumentValue, total = 0,
            items;
        if (arguments.length === 1) {
            if (typeof values === 'object' && Array.isArray(values.values)) {
                items = values.values[0];
                return items.reduce(function(i, prev) {
                    return prev + i;
                });
            } else if (Array.isArray(values)) {
                return values.reduce(function(i, prev) {
                    return prev + i;
                });
            } else {

                return values;
            }
        }
        for (var i = 0; i < arguments.length; i++) {
            argumentValue = arguments[i];
            if (typeof argumentValue === 'object' && Array.isArray(argumentValue.values)) {
                argumentValue = argumentValue.values[0];
            }
            if (!isNaN(parseFloat(argumentValue))) {
                total += parseFloat(argumentValue);
            }
        }
        return total;
    },
    DIFFERENCE: function(a, b) {
        var first = a,
            second = b;

        // arguments are propertySets
        if (typeof a === 'object' && Array.isArray(a.values)) {
            first = a.values[0];
        }
        if (typeof b === 'object' && Array.isArray(b.values)) {
            second = b.values[0];
        }
        if (!isNaN(parseFloat(first)) && !isNaN(parseFloat(second))) {
            return parseFloat(first) - parseFloat(second);
        } else {
            return NaN;
        }
    },
    EQUALS:function(a,b){
         var first = a,
            second = b;

        // arguments are propertySets
        if (typeof a === 'object' && Array.isArray(a.values)) {
            first = a.values[0];
        }
        if (typeof b === 'object' && Array.isArray(b.values)) {
            second = b.values[0];
        }
        return first===second;
    }
};
