// wrapper to allow export as AMD in browser
(function() {
    'use strict';

    var methods,
        exports = {
            returnObject: {
                score: 0,
                properties: {
                    matches: {},
                    fails: {}
                }
            },

            // transitional code to allow multiple styles of context arguments
            normalizeContexts: function(contexts, rules) {

                exports.dataLookup = {};
                exports.contextsList = [];
                exports.reducersList = {};
                exports.lookupRules = [];
                rules.forEach(function(rule) {
                    if (rule.id) {
                        exports.lookupRules[rule.id] = rule;
                    }
                });
                exports.contextsList = [{
                    type: contexts.type,
                    particle: contexts,
                    side: contexts.data && contexts.data.side ? contexts.data.side : null
                }];
                exports.reducersList = {};
                exports.dataLookup = contexts;
                
                // transform context publishes arrays to rule publishes arrays (transitional)
                exports.contextsList.every(function(contextObject) {
                    if (contextObject.particle && contextObject.particle.data && contextObject.particle.data['current-period']) {
                        exports.currentPeriod = contextObject.particle.data['current-period'];
                    }
                    if (!contextObject.particle.publishes || !contextObject.particle.publishes.length) {
                        return;
                    }
                    contextObject.particle.publishes.forEach(function(publish) {
                        if (publish.ruleId && exports.lookupRules[publish.ruleId]) {
                            if (!exports.lookupRules[publish.ruleId].publishes) {
                                exports.lookupRules[publish.ruleId].publishes = [];
                            }
                            exports.lookupRules[publish.ruleId].publishes.push(publish);
                        }
                    });
                });

            },

            // initialize and call subRules iterator
            score: function(context, rule) {
                var matches, rules = !Array.isArray(rule) ? [rule] : rule;
                rules = JSON.parse(JSON.stringify(rules));
                exports.normalizeContexts(context, rules);
                exports.returnedPublishes = [];
                rules.map(function(rule) {
                    if (!rule.rule) {
                        rule = {
                            rule: rule
                        };
                    }
                    var side = exports.contextsList[0].side;
                    var sideAmendedRule = JSON.parse(JSON.stringify(rule)),
                        publishInPeriod = rule.rule.publishInPeriod || [1, 2, 3, 4, 5],
                        reducerTypes = [],
                        attr;

                    exports.returnObject = {
                        score: 0,
                        properties: {
                            matches: {},
                            fails: {}
                        }
                    };
                    exports.returnedParticle = exports.contextsList[0].particle;
                    exports.returnObject.particle = exports.returnedParticle;
                    if (rule.id) {
                        exports.returnObject.ruleId = rule.id;
                    }
                    if (rule.particle) {
                        reducerTypes = typeof rule.particle['reducer-type'] === 'object' ? rule.particle['reducer-type'] : [rule.particle['reducer-type']];

                        // the template sub-context values are intitialized here, but may be provided or amended by rule execution
                        if (rule.particle['particle-type']) {
                            exports.returnObject['particle-type'] = rule.particle['particle-type'];
                        }

                        // add defualt templates from rule to return object
                        if (rule.particle.config && rule.particle.config.render) {
                            for (attr in rule.particle.config.render) {
                                exports.returnObject[attr] = rule.particle.config.render[attr];
                            }
                        }
                    }
                    if (side) {
                        if (exports.returnedParticle.data) {
                            exports.returnedParticle.data.side = side || 'both';
                        }
                        exports.returnObject.side = side;
                    }

                    // only check rule if context relates to current period or current-period not specified
                    if (exports.currentPeriod && exports.currentPeriod.id &&
                        publishInPeriod.indexOf(exports.currentPeriod.id) === -1
                    ) {
                        exports.returnedPublishes.push(exports.returnObject);
                        return;
                    }
                    matches = exports.subScore(exports.dataLookup, sideAmendedRule.rule);
                    for (attr in exports.returnObject) {
                        if (!matches[attr]) {
                            matches[attr] = exports.returnObject[attr];
                        }
                    }
                    exports.returnedPublishes.push(matches);
                });
                return exports.returnedPublishes;
            }
        };

    methods = require('./pointerMethods.js');
    exports.subScore = require('./subScore.js').subScore;
    module.exports = {
        score: exports.score
    };

})();
